From e591dfbf3fe478d47d6bf0f3d28846d0579b008d Mon Sep 17 00:00:00 2001
From: Ilya Shpigor <shpigor@etersoft.ru>
Date: Fri, 22 May 2009 16:52:24 +0400
Subject: [PATCH 3/3] user32: Redraw on SetWindowPos only for some types of windows (eterbug #3971 #969)

---
 dlls/user32/winpos.c |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

diff --git a/dlls/user32/winpos.c b/dlls/user32/winpos.c
index b0afd24..cbdbf10 100644
--- a/dlls/user32/winpos.c
+++ b/dlls/user32/winpos.c
@@ -1939,17 +1939,17 @@ BOOL USER_SetWindowPos( WINDOWPOS * winpos )
         return FALSE;
     else if (winpos->flags & SWP_SHOWWINDOW)
     {
-        if (GetWindow( winpos->hwnd, GW_CHILD ) ||
-            !(GetWindowLongW( winpos->hwnd, GWL_EXSTYLE ) & WS_EX_TOOLWINDOW))
+        if (GetWindow( winpos->hwnd, GW_CHILD )
+            || (GetWindowLongW( winpos->hwnd, GWL_STYLE ) & WS_CHILD))
         {
             RECT rc;
             GetClientRect( winpos->hwnd, &rc );
             RedrawWindow( winpos->hwnd, &rc, 0,
                             (RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN) );
         }
-        else
-            SendMessageW( winpos->hwnd, WM_PRINT, (WPARAM)GetDC(winpos->hwnd),
-                            (LPARAM)(PRF_CLIENT | PRF_ERASEBKGND | PRF_NONCLIENT) );
+        else if (GetWindowLongW( winpos->hwnd, GWL_EXSTYLE ) & WS_EX_TOOLWINDOW)
+             SendMessageW( winpos->hwnd, WM_PRINT, (WPARAM)GetDC(winpos->hwnd),
+                             (LPARAM)(PRF_CLIENT | PRF_ERASEBKGND | PRF_NONCLIENT) );
     }
 
     /* erase parent when hiding or resizing child */
-- 
1.6.2.5

